unit MasterMind;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, StdCtrls, Buttons, MPlayer;

const LochAnzahl=6;
type
  TListe=Array[1..LochAnzahl]of Integer;
  TMaster = class(TForm)
    PanelVersuche: TPanel;
    MainMenu: TMainMenu;
    Spiel: TMenuItem;
    Neu: TMenuItem;
    CodeAnzeige: TMenuItem;
    N1: TMenuItem;
    Beenden: TMenuItem;
    Level: TMenuItem;
    Farben3: TMenuItem;
    Farben4: TMenuItem;
    Hilfe: TMenuItem;
    Regeln: TMenuItem;
    N2: TMenuItem;
    Info: TMenuItem;
    PanelOben: TPanel;
    VAnzeige: TImage;
    PanelFarben: TPanel;
    FarbAnzeige: TImage;
    PanelLoesung: TPanel;
    LoesungAnzeige: TImage;
    Teste: TBitBtn;
    Kopie: TBitBtn;
    PanelVNr: TPanel;
    LabelVNr: TLabel;
    Optionen: TMenuItem;
    Soundan: TMenuItem;
    MediaPlayer: TMediaPlayer;
    Farben5: TMenuItem;
    Farben6: TMenuItem;
    Uhr: TTimer;
    procedure BeendenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Init;
    procedure Farben3Click(Sender: TObject);
    procedure Farben4Click(Sender: TObject);
    procedure FarbAnzeigeMouseDown(Sender: TObject; Button: TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
    procedure VAnzeigeDragOver(Sender, Source: TObject; X, Y: Integer;
                               State: TDragState; var Accept: Boolean);
    procedure VAnzeigeDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure VAnzeigeEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure TesteClick(Sender: TObject);
    procedure KopieClick(Sender: TObject);
    procedure SoundanClick(Sender: TObject);
    procedure Sound(Datei:String);
    procedure FarbTest(Code,Versuch:TListe;Var Schwarz,Weiss:Integer);
    procedure InfoClick(Sender: TObject);
    procedure RegelnClick(Sender: TObject);
    procedure CodeAnzeigeClick(Sender: TObject);
    procedure NeuClick(Sender: TObject);
    procedure VAnzeigeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Farben5Click(Sender: TObject);
    procedure Farben6Click(Sender: TObject);
    procedure UhrTimer(Sender: TObject);
  private
    { Private-Deklarationen }
   Farbe:Array[0..8]of TColor;
   CodeListe,AlteFarbListe,FarbListe:TListe;
   FarbArray:Array[0..9]of TLIste;
   MitteVersuche,MitteFarben:Array[1..LochAnzahl]of TPoint;
   FarbAnzahl,Versuch,FarbNr,Gefuellt:Integer;
   IsDragging:Boolean;
   Geheim:String;
  public
    { Public-Deklarationen }
  end;

var Master: TMaster;

implementation

uses Info, Regeln, Passwort;

{$R *.dfm}
{$R MMCursor.RES}
{$R+,Q+}
 const crSuperhirn=1;Radius=15;

 procedure TMaster.BeendenClick(Sender: TObject);
  begin close end;

 procedure TMaster.Init;
  var K,Z,Rechts:Integer;
  begin
   if Farben4.Checked then
    begin
     for K:=1 to FarbAnzahl do
      CodeListe[K]:=Random(8)+1; // Farbkombination definieren
    end
   else
    begin
     CodeListe[1]:=Random(8)+1;
     repeat
      CodeListe[2]:=Random(8)+1;
     until CodeListe[1]<>CodeListe[2];
     repeat
      CodeListe[3]:=Random(8)+1;
     until (CodeListe[1]<>CodeListe[3]) and (CodeListe[2]<>CodeListe[3]);
    end;
   FillChar(FarbArray,SizeOf(FarbArray),0);
   Versuch:=1;Gefuellt:=0;
   LabelVNr.Caption:=IntToStr(Versuch);
   Teste.Enabled:=False;
   Kopie.Enabled:=False;
   FarbAnzeige.Enabled:=True;
   VAnzeige.Enabled:=True;
   with VAnzeige.Canvas do
    begin
     Brush.Color:=clBtnFace;
     FillRect(Rect(0,0,VAnzeige.Width,VAnzeige.Height));
     Font.Name:='Arial';
     Font.Size:=10;
     Font.Style:=[fsBold];
     for Z:=0 to 9 do
      begin
       for K:=1 to FarbAnzahl do
        begin
         Pen.Color:=clBlack;
         Brush.Style:=bsClear;
         MitteVersuche[K].X:=(20*K+2*K*Radius+Radius)div 2;
         MitteVersuche[K].Y:=(20+Radius)div 2;
         Ellipse(10*K+K*Radius,10+5*Z+Radius*Z,10*K+(K+1)*Radius,10+5*Z+Radius*(Z+1));
        end;
       if Z=0 then Font.Color:=clGreen // VersuchsNummer
       else Font.Color:=clRed;
       if Z=9 then Rechts:=4 else Rechts:=10;
       TextOut(Rechts,10+(Radius+5)*Z,IntToStr(Z+1));
       Font.Color:=clBlack; // Farbe an der richtigen Position
       TextOut(186,10+(Radius+5)*Z,'?');
       Font.Color:=clWhite; // richtige Farbe an der falschen Position
       TextOut(204,10+(Radius+5)*Z,'?');
      end;
    end;
   with FarbAnzeige.Canvas do
    begin
     Brush.Color:=clBtnFace;
     FillRect(Rect(0,0,FarbAnzeige.Width,FarbAnzeige.Height));
     for Z:=0 to 1 do
      for K:=1 to 4 do
       begin
        Pen.Color:=clBlack;
        Brush.Style:=bsClear;
        Brush.Color:=Farbe[K+4*Z];
        MitteFarben[K].X:=(16*(K-2)+2*K*Radius+Radius)div 2;
        MitteFarben[K].Y:=(12+Radius)div 2;
        Ellipse(8*(K-2)+K*Radius,6+5*Z+Radius*Z,8*(K-2)+(K+1)*Radius,6+5*Z+Radius*(Z+1));
      end;
    end;
   with LoesungAnzeige.Canvas do
    begin
     Brush.Color:=clBtnFace;
     FillRect(Rect(0,0,LoesungAnzeige.Width,LoesungAnzeige.Height));
     for K:=1 to FarbAnzahl do
      begin
       Pen.Color:=clBlack;
       Brush.Style:=bsClear;
       Ellipse(8*(K-2)+K*10,4,8*(K-2)+(K+1)*10,14);
      end;
    end;
  end;

 procedure TMaster.FormCreate(Sender: TObject);
  var Name:String;
      K,LA:Integer;
  begin
   RandSeed:=3062;Name:='D_';Geheim:='';LA:=223;
   for K:=1 to 6 do
    Geheim:=Geheim+char(32+(ord(Name[K])-Random(LA)+LA-32) mod LA);
   Screen.Cursors[crSuperhirn]:=LoadCursor(HInstance,'DragCursor');
   VAnzeige.DragCursor:=crSuperhirn;
   FarbAnzeige.DragCursor:=crSuperhirn;
   Farbe[0]:=clBtnFace;Farbe[1]:=clWhite;Farbe[2]:=clRed;
   Farbe[3]:=clYellow; Farbe[4]:=clGreen;Farbe[5]:=clFuchsia;
   Farbe[6]:=clAqua;   Farbe[7]:=clBlue; Farbe[8]:=clBlack;
   FarbAnzahl:=4;Randomize;Init;
   Uhr.Enabled:=False;
  end;

 procedure TMaster.Farben3Click(Sender: TObject);
  begin
   Farben3.Checked:=True;
   FarbAnzahl:=3;
   Init;
  end;

 procedure TMaster.Farben4Click(Sender: TObject);
  begin
   Farben4.Checked:=True;
   FarbAnzahl:=4;
   Init;
  end;

 procedure TMaster.Farben5Click(Sender: TObject);
  begin
   Farben5.Checked:=True;
   FarbAnzahl:=5;
   Init;
  end;

 procedure TMaster.Farben6Click(Sender: TObject);
  begin
   Farben6.Checked:=True;
   FarbAnzahl:=6;
   Init;
  end;

 procedure TMaster.FarbAnzeigeMouseDown(Sender: TObject;Button: TMouseButton;
                                        Shift: TShiftState; X, Y: Integer);
  var K,Z:Integer;
  begin
   if Shift=[ssLeft] then
    begin
     for Z:=0 to 1 do
      for K:=1 to 4 do
       if sqr(MitteFarben[K].X-X)+sqr(MitteFarben[K].Y+(Radius+5)*Z-Y)<=sqr(Radius) then
        begin
         FarbNr:=K+4*Z;IsDragging:=True;
         FarbAnzeige.BeginDrag(True);
         Exit;
        end
    end
  end;

 procedure TMaster.VAnzeigeMouseDown(Sender: TObject; Button: TMouseButton;
                                     Shift: TShiftState; X, Y: Integer);
  var K,Z:Integer;
  begin
   if Shift=[ssLeft] then
    begin
     for Z:=0 to Versuch-1 do
      for K:=1 to FarbAnzahl do
       if sqr(MitteVersuche[K].X-X)+sqr(MitteVersuche[K].Y+(Radius+5)*Z-Y)<=sqr(Radius) then
        begin
         FarbNr:=FarbArray[Z,K];IsDragging:=True;
         VAnzeige.BeginDrag(True);
         Exit;
        end
    end
  end;

 procedure TMaster.VAnzeigeDragOver(Sender, Source: TObject; X, Y: Integer;
                                    State: TDragState; var Accept: Boolean);
  var K:Integer;
  begin
   Accept:=False;
   if ((Source is TImage) and (TImage(Source).Name='FarbAnzeige') and
       (Sender is TImage) and (TImage(Sender).Name='VAnzeige')) or
      ((Source is TImage) and (TImage(Source).Name='VAnzeige') and
       (Sender is TImage) and (TImage(Sender).Name='VAnzeige'))then
    begin
     for K:=1 to FarbAnzahl do
      if sqr(MitteVersuche[K].X-X)+sqr(MitteVersuche[K].Y+(Radius+5)*(Versuch-1)-Y)<=sqr(Radius) then
       begin
        Accept:=True;
        Exit;
       end
    end
  end;

 procedure TMaster.VAnzeigeDragDrop(Sender, Source: TObject; X, Y: Integer);
  var K:Integer;
  begin
   for K:=1 to FarbAnzahl do
    if sqr(MitteVersuche[K].X-X)+sqr(MitteVersuche[K].Y+(Radius+5)*(Versuch-1)-Y)<=sqr(Radius) then
     with VAnzeige.Canvas do
      begin
       Pen.Color:=clBlack;
       Brush.Style:=bsClear;
       Brush.Color:=Farbe[FarbNr];
       FarbListe[K]:=FarbNr;
       FarbArray[Versuch-1,K]:=FarbNr;
       Ellipse(10*K+K*Radius,10+(Radius+5)*(Versuch-1),10*K+(K+1)*Radius,10+5*(Versuch-1)+Radius*Versuch);
       if FarbNr>0 then inc(Gefuellt)
       else if Gefuellt>0 then dec(Gefuellt);
       if Gefuellt=FarbAnzahl then Teste.Enabled:=True;
       if SoundAn.Checked then Sound('drop.wav');
       Exit;
      end
  end;

 procedure TMaster.VAnzeigeEndDrag(Sender, Target: TObject; X, Y: Integer);
  begin
   if IsDragging then IsDragging:=False;
  end;

 procedure TMaster.FarbTest(Code,Versuch:TListe;Var Schwarz,Weiss:Integer);
  var K,L:Integer;
  begin
   Schwarz:=0;Weiss:=0;
   for K:=1 to FarbAnzahl do
    if Code[K]=Versuch[K] then
     begin inc(Schwarz);Code[K]:=0;Versuch[K]:=-1 end;
   for K:=1 to FarbAnzahl do
    for L:=1 to FarbAnzahl do
     if Code[K]=Versuch[L] then
      begin inc(Weiss);Code[K]:=0;Versuch[L]:=-1 end;
  end;

 procedure TMaster.TesteClick(Sender: TObject);
  var Rechts,K,S,W,Z:Integer;
  begin
   Kopie.Enabled:=True;
   Teste.Enabled:=False;
   AlteFarbListe:=FarbListe;
   FarbArray[Versuch-1]:=FarbListe;
   Gefuellt:=0;
   // Anzahl der schwarzen und weien Stifte ermitteln
   FarbTest(CodeListe,FarbListe,S,W);
   Z:=Versuch-1;
   with VAnzeige.Canvas do
    begin
     Brush.Color:=clBtnFace;
     Font.Color:=clBlack; // Farbe an der richtigen Position
     TextOut(186,10+(Radius+5)*Z,IntToStr(S));
     Font.Color:=clWhite; // richtige Farbe an der falschen Position
     TextOut(204,10+(Radius+5)*Z,IntToStr(W));
    end;
   if S=FarbAnzahl then
    begin
     MessageDlg('Du bist ein guter Logiker!',mtInformation,[mbOk],0);
     Kopie.Enabled:=False;
     Teste.Enabled:=False;
     FarbAnzeige.Enabled:=False;
     VAnzeige.Enabled:=False;
    end
   else
    if Versuch=10 then
     begin
      MessageDlg('Du bist ein Loooser!',mtConfirmation,[mbOk],0);
      Kopie.Enabled:=False;
      Teste.Enabled:=False;
      FarbAnzeige.Enabled:=False;
      VAnzeige.Enabled:=False;
      with LoesungAnzeige.Canvas do
       begin
        Brush.Color:=clBtnFace;
        FillRect(Rect(0,0,LoesungAnzeige.Width,LoesungAnzeige.Height));
        for K:=1 to FarbAnzahl do
         begin
          Pen.Color:=clBlack;
          Brush.Style:=bsClear;
          Brush.Color:=Farbe[CodeListe[K]];
          Ellipse(8*(K-2)+K*Radius,6,8*(K-2)+(K+1)*Radius,6+Radius);
         end;
    end;
     end
    else
     begin
      with VAnzeige.Canvas do
       begin
        Brush.Color:=clBtnFace;
        Font.Color:=clRed;
        TextOut(10,10+(Radius+5)*(Versuch-1),IntToStr(Versuch));
        Font.Color:=clGreen;
        if Versuch=9 then Rechts:=4 else Rechts:=10;
        TextOut(Rechts,10+(Radius+5)*(Versuch),IntToStr(Versuch+1));
       end;
      inc(Versuch);
      LabelVNr.Caption:=IntToStr(Versuch);
     end;
  end;

 procedure TMaster.KopieClick(Sender: TObject);
  var K:Integer;
  begin
   Kopie.Enabled:=False;
   Teste.Enabled:=True;
   Gefuellt:=FarbAnzahl;
   FarbListe:=AlteFarbListe;
   FarbArray[Versuch-1]:=FarbListe;
   for K:=1 to FarbAnzahl do
    with VAnzeige.Canvas do
     begin
      Pen.Color:=clBlack;
      Brush.Style:=bsClear;
      Brush.Color:=Farbe[FarbListe[K]];
      Ellipse(10*K+K*Radius,10+(Radius+5)*(Versuch-1),10*K+(K+1)*Radius,10+5*(Versuch-1)+Radius*Versuch);
     end
  end;

 procedure TMaster.Sound(Datei:String);
  begin
   try
    MediaPlayer.DeviceType:=dtAutoSelect;
    MediaPlayer.FileName:=Datei;
    MediaPlayer.Open;
    MediaPlayer.wait:=true;
    MediaPlayer.Play;
    MediaPlayer.Close;
   except
    On EMCIDeviceError do
     MessageDlg('Die Datei '+Datei+' wurde NICHT gefunden!',mtError,[mbRetry],0)
    end;
  end;

 procedure TMaster.SoundanClick(Sender: TObject);
  begin
   Soundan.Checked:=not Soundan.Checked;
  end;

 procedure TMaster.InfoClick(Sender: TObject);
  begin
   InfoBox.ShowModal;
  end;

 procedure TMaster.RegelnClick(Sender: TObject);
  begin
   RegelnBox.ShowModal;
  end;

 procedure TMaster.CodeAnzeigeClick(Sender: TObject);
  var K:Integer;
  begin
   PasswordDlg.ShowModal;
   if PasswordDlg.Passwort.Text<>Geheim then exit;
   Uhr.Enabled:=True;
   with LoesungAnzeige.Canvas do
    begin
     Brush.Color:=clBtnFace;
     FillRect(Rect(0,0,LoesungAnzeige.Width,LoesungAnzeige.Height));
     for K:=1 to FarbAnzahl do
      begin
       Pen.Color:=clBlack;
       Brush.Style:=bsClear;
       Brush.Color:=Farbe[CodeListe[K]];
       Ellipse(8*(K-2)+K*10,4,8*(K-2)+(K+1)*10,14);
      end;
    end;
  end;

 procedure TMaster.NeuClick(Sender: TObject);
  begin
   Init;
  end;

 procedure TMaster.UhrTimer(Sender: TObject);
  var K:Integer;
  begin
   with LoesungAnzeige.Canvas do
    begin
     Brush.Color:=clBtnFace;
     FillRect(Rect(0,0,LoesungAnzeige.Width,LoesungAnzeige.Height));
     for K:=1 to FarbAnzahl do
      begin
       Pen.Color:=clBlack;
       Brush.Style:=bsClear;
       Ellipse(8*(K-2)+K*10,4,8*(K-2)+(K+1)*10,14);
      end;
     Uhr.Enabled:=False;
    end
  end;

end.

